According to a post on Apple's developer website, all developers will be required to submit apps that are compatible with iOS 7 and built with Xcode 5 as of February 1, 2014.

Until now, the App Store has been accepting the submission of both apps that were built from the ground up for iOS 7 as well as those that were built for iOS 6 using older versions of the company's developer toolset. This was done primarily as a temporary measure, so that companies with existing apps wouldn't have to choose between abandoning their users who chose not to upgrade to the latest version of Apple's operating system or supporting both iOS 6 and 7 in a single executable--which, given the user interface differences between the two versions of iOS, would be a pretty significant challenge.

Instead, Apple built much of the "old" iOS 6 UI into iOS 7, allowing developers to take advantage of it if they so chose. As developer liaison David Duncan explained earlier this month on one of the company's mailing lists, this means that apps built against the older operating system "get a compatible styling (it[']s not exactly iOS 6, and it[']s certainly not iOS 7, but it[']s somewhere in between while still looking like an iOS 6 app)."

As adoption of iOS 7 continues to grow at a rapid pace, the need for iOS 6 compatibility is waning, and it's likely that Apple has simply chosen to forego support for apps built against the older interface for a couple reasons. First, keeping programmers on a particular set of tools means having to support fewer different technologies--on a large scale, this means that Apple's engineers will need to keep track fewer pieces of software and be able to focus their developer assistance efforts on a smaller range of possible issues.

In the longer run, getting rid of iOS 6 support will also make iOS 7 (and its successors) easier to maintain and smaller--a definite plus as the operating system continues to grow in complexity and the company's ecosystem plays host to an increasing number of devices.

Note, however, that this doesn't mean that Apple is preventing developers from submitting versions of their apps that will work on older versions of iOS--as long as they fully support iOS 7's native interface paradigms as well. Likewise, existing apps are grandfathered in as long they aren't updated, but any subsequent updates will have to adhere to the rule. 

In practice, however, given how different iOS 7's UI is, it's likely that many developers will themselves forego support for previous iOS versions, resulting in fewer choices for owners of devices that, like the first-generation iPad and iPhone 3GS, cannot be updated to the most recent releases of Apple's mobile software.